module pwm(clk, rst, compareHin, compareLin, peakin, outH, outL);
    input clk, rst;
    input [16:1] compareHin;
    input [16:1] compareLin;

    input [16:1] peakin;
    output reg outH;
    output reg outL;
    reg dir;
    reg [16:1] sr;
    reg [16:1] compareH;
    reg [16:1] compareL;
    reg [16:1] peak;

    
    always @(posedge clk)
    begin
        if (rst) begin
            sr  = 0;
            dir = 1;
            outH = 0;
            outL = 0;
            peak = 160;
        end
        else begin
			if (dir) begin
				sr <= sr + 1;
			end
			
			if (dir == 0) begin
				sr <= sr - 1;
				compareH = compareHin;
				compareL = compareLin;
				peak = peakin;
			end
			
			if (sr == peak) begin
				dir = 0;
			end
			if (sr == 0) begin
				dir = 1;
			end
			
			if (compareH == sr) begin
				outH = !dir;
			end
			if (compareL == sr) begin
				outL = dir;
			end
            //outH <= (compareH > sr) 
            //outL <= (compareL < sr);
        end
    end
endmodule
